/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.arrebol.apc.web.beans.admin;

import com.arrebol.apc.controller.GenericController;
import com.arrebol.apc.controller.admin.StatsClosingDayController;
import com.arrebol.apc.model.core.User;
import com.arrebol.apc.model.views.StatsClosingDayView;
import com.arrebol.apc.web.beans.Datatable;
import com.arrebol.apc.web.beans.GenericBean;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Calendar;
import java.util.List;
import javax.annotation.PostConstruct;
import javax.faces.application.FacesMessage;
import javax.faces.view.ViewScoped;
import javax.inject.Named;
import org.primefaces.event.ReorderEvent;
import org.primefaces.event.RowEditEvent;

/**
 *
 * @author David Rodriguez
 */
@Named("statsClosingDayManager")
@ViewScoped
public class StatsClosingDayBean extends GenericBean implements Serializable, Datatable {

    public void searchHistoricalAction() {
        try {
            if (getStarDate().after(getEndDate())) {
                showMessage(FacesMessage.SEVERITY_ERROR, getBundlePropertyFile().getString("generic.start.date"), getBundlePropertyFile().getString("generic.end.date.error"));
            } else {
                setClosingDay(fillDatatableClosingDay());
                setTotalValue();
            }
        } catch (Exception e) {
        }
    }

    public BigDecimal searchTotalClosingDayAction() {
        try {
            if (getStarDate().after(getEndDate())) {
                showMessage(FacesMessage.SEVERITY_ERROR, getBundlePropertyFile().getString("generic.start.date"), getBundlePropertyFile().getString("generic.end.date.error"));
            } else {
                setTotalValue();
            }
        } catch (Exception e) {
        }
        return getTotalClosingDay();
    }

    public StatsClosingDayController getClosingDayCtrl() {
        return closingDayCtrl;
    }

    public void setClosingDayCtrl(StatsClosingDayController closingDayCtrl) {
        this.closingDayCtrl = closingDayCtrl;
    }

    public GenericController getGenericCtrl() {
        return genericCtrl;
    }

    public void setGenericCtrl(GenericController genericCtrl) {
        this.genericCtrl = genericCtrl;
    }

    public List<StatsClosingDayView> fillDatatableClosingDay() {
        return getClosingDayCtrl().fillClosingDayDataTable(getStarDate(), getEndDate(), getUserSelectedId());
    }

    public BigDecimal fillTotalClosingDay() {
        return getClosingDayCtrl().fillTotalClosingDay(getStarDate(), getEndDate());
    }

    public List<StatsClosingDayView> getClosingDay() {
        return closingDay;
    }

    public void setClosingDay(List<StatsClosingDayView> closingDay) {
        this.closingDay = closingDay;
    }

    public StatsClosingDayView getSelectedClosingDay() {
        return selectedClosingDay;
    }

    public void setSelectedClosingDay(StatsClosingDayView selectedClosingDay) {
        this.selectedClosingDay = selectedClosingDay;
    }

    public BigDecimal getTotalClosingDay() {
        return totalClosingDay;
    }

    public void setTotalClosingDay(BigDecimal totalClosingDay) {
        this.totalClosingDay = totalClosingDay;
    }
    
    public List<User> getUsers() {
        return genericCtrl.getAllUsersByOffice(getLoggedUser().getOffice().getId());
    }
    
    public String getUserSelectedId() {
        return userSelectedId;
    }

    public void setUserSelectedId(String userSelectedId) {
        this.userSelectedId = userSelectedId;
    }

    private StatsClosingDayController closingDayCtrl;
    private GenericController genericCtrl;
    private List<StatsClosingDayView> closingDay;
    private StatsClosingDayView selectedClosingDay;
    private BigDecimal totalClosingDay;
    private List<User> users;
    private String userSelectedId;

    @PostConstruct
    public void init() {
        loadBundlePropertyFile();
        initStartAndEndDates(Calendar.DAY_OF_WEEK, 2);

        closingDayCtrl = new StatsClosingDayController();
        genericCtrl = new GenericController();
        closingDay = fillDatatableClosingDay();
        setTotalValue();
        users = getUsers();
    }

    @Override
    public void editRow(RowEditEvent event) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void onRowCancel(RowEditEvent event) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void onRowReorder(ReorderEvent event) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void addRow() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void deleteRow() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
    private void setTotalValue() {
        if (closingDay != null && !closingDay.isEmpty()) {
            setTotalClosingDay(closingDay.stream().map(StatsClosingDayView::getTotalClosingDay).reduce(BigDecimal::add).get());
        } else {
            setTotalClosingDay(BigDecimal.ZERO);
        }
    }
}
